SystemOrganization addCategory: #'Glamour-FastTable'!
SystemOrganization addCategory: 'Glamour-FastTable-Announcement'!
SystemOrganization addCategory: 'Glamour-FastTable-Model'!
SystemOrganization addCategory: 'Glamour-FastTable-Morphic-Renderer'!
SystemOrganization addCategory: 'Glamour-FastTable-Presentations'!

Trait named: #TGLMFastTable
	uses: {}
	category: 'Glamour-FastTable-Model'!

!TGLMFastTable commentStamp: 'CyrilFerlicot 11/10/2015 11:45' prior: 0!
I am a Trait that manage some Glamour Model related functionalities. 

Description 
--------------------

I contains some functionnalities used by all the Glamour related data sources like the annoucements. Since a dataSource can be a list, or a outline list, or a tree … They cannot inherit from the same class. I am here to avoid a duplication of code.!

!TGLMFastTable classSide methodsFor: 'accessing - cache' stamp: 'AndreiChis 3/6/2017 11:43'!
defaultCache
	^ LRUCache new maximumWeight: 128! !

!TGLMFastTable methodsFor: 'accessing' stamp: 'usmanbhatti 11/16/2015 15:21'!
allMenuActions
	^ self glamourPresentation allSelectionActions select: #hasTitle! !

!TGLMFastTable methodsFor: 'announcing' stamp: 'CyrilFerlicot 11/4/2015 17:12'!
announcer
	self explicitRequirement! !

!TGLMFastTable methodsFor: 'private' stamp: 'CyrilFerlicot 11/10/2015 11:56'!
basicElements
	^ self glamourPresentation displayValue! !

!TGLMFastTable methodsFor: 'accessing - cache' stamp: 'AndreiChis 3/6/2017 11:17'!
cacheAt: aKey for: anElement ifAbsentPut: aBlock
	| elementCache |
	
	self shouldUseCache ifFalse: [ 
		^ aBlock value ].
	
	elementCache := self dataCacheFor: anElement.
	(elementCache includesKey: aKey) 
		ifTrue: [ ^ elementCache at: aKey ].
		
	^ aBlock value 
		ifNotNil: [ :anObject | elementCache at: aKey ifAbsentPut: [ anObject ] ]! !

!TGLMFastTable methodsFor: 'private' stamp: 'AndreiChis 2/10/2017 00:24'!
calculateElements
	^ self tagsToFilterBy 
		ifEmpty: [ self basicElements ]
		ifNotEmpty: [ self basicElements select: [ :each | self elementShouldBeDisplayed: each ]. ]
! !

!TGLMFastTable methodsFor: 'private' stamp: 'CyrilFerlicot 11/10/2015 11:56'!
collectionToDragPassenger: aCollection
	^ aCollection size = 1
		ifTrue: [ aCollection anyOne ] 
		ifFalse: [ aCollection ]! !

!TGLMFastTable methodsFor: 'cache' stamp: 'AndreiChis 3/6/2017 08:01'!
dataCache
	self explicitRequirement! !

!TGLMFastTable methodsFor: 'cache' stamp: 'AndreiChis 3/6/2017 11:49'!
dataCacheFor: anElement.

	^ self dataCache at: anElement ifAbsentPut: [ Dictionary new ]! !

!TGLMFastTable methodsFor: 'private' stamp: 'CyrilFerlicot 11/10/2015 11:56'!
elementOrZeroAt: rowIndex
	^ rowIndex = 0 
		ifTrue: [ 0 ] 
		ifFalse: [ self elementAt: rowIndex ] 
	! !

!TGLMFastTable methodsFor: 'private' stamp: 'CyrilFerlicot 11/10/2015 11:56'!
elementShouldBeDisplayed: anObject
	| elementTags |
	self tagsToFilterBy ifEmpty: [ ^ true ].
	elementTags := self glamourPresentation tagsFor: anObject to: #filter.
	^ self tagsToFilterBy allSatisfy: [ :each | elementTags includes: each ]! !

!TGLMFastTable methodsFor: 'menu' stamp: 'CyrilFerlicot 11/4/2015 17:22'!
executeMenuAction: anAction
	self announcer announce: (GLMMenuItemSelected action: anAction)! !

!TGLMFastTable methodsFor: 'selecting' stamp: 'CyrilFerlicot 1/5/2016 12:15'!
explicitSelection: anObject 
	self table selectRowIndex: (self elements indexOf: anObject)! !

!TGLMFastTable methodsFor: 'accessing - cache' stamp: 'AndreiChis 3/5/2017 18:31'!
formatedDisplayValueOf: anElement
	^ self 
		cacheAt: #formatedDisplayValue 
		for: anElement 
		ifAbsentPut: [ self glamourPresentation formatedDisplayValueOf: anElement ]! !

!TGLMFastTable methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/9/2015 10:49'!
glamourPresentation
	self explicitRequirement! !

!TGLMFastTable methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/9/2015 10:49'!
glamourPresentation: anObject
	self explicitRequirement! !

!TGLMFastTable methodsFor: 'accessing - cache' stamp: 'AndreiChis 3/5/2017 18:17'!
iconFor: anElement
	^ self 
		cacheAt: #icon 
		for: anElement 
		ifAbsentPut: [ self glamourPresentation icon cull: anElement ]! !

!TGLMFastTable methodsFor: 'menu' stamp: 'PabloTesone 10/11/2016 11:00'!
menuColumn: column row: rowIndex
	| menu subMenus targetMenuMorph subMenu |
	
	menu := UIManager default newMenuIn: self table for: self.
	subMenus := Dictionary new.
	self allMenuActions do: [ :action |
		targetMenuMorph := action category notNil 
			ifTrue: [ subMenus at: action category ifAbsentPut: [ 
					subMenu :=  MenuMorph new.
					menu add: action category subMenu: subMenu.
					subMenu ] ]
			ifFalse: [ menu ].
		(targetMenuMorph 
			add: action title
			target: self
			selector: #executeMenuAction:
			argument: action)
			icon:  action icon;
			enabled: (action isEnabledOn: self glamourPresentation);
			keyText: (action hasShortcut 
				ifTrue: [ action shortcutAsString ]
				ifFalse: [ nil ]) ].
	^ menu! !

!TGLMFastTable methodsFor: 'instance creation' stamp: 'JurajKubelka 4/10/2017 11:24'!
newDataSourceMatching: aFTFilter
	^ (super newDataSourceMatching: aFTFilter)
		glamourPresentation: self glamourPresentation;
		yourself! !

!TGLMFastTable methodsFor: 'private' stamp: 'usmanbhatti 11/17/2015 10:28'!
readyToBeDisplayed
	self glamourPresentation announcer announce: (GLMDataSourceUpdated newDataSource: self).! !

!TGLMFastTable methodsFor: 'cache' stamp: 'AndreiChis 3/5/2017 21:56'!
resetDataCache
	self explicitRequirement! !

!TGLMFastTable methodsFor: 'selecting' stamp: 'AndreiChis 2/2/2017 19:38'!
selection: ann
	| selection |
	selection := ann newSelectedRowIndexes select: [ :each | each ~= 0 ] thenCollect: [ :each | self elementAt: each ].
	selection
		ifNotEmpty: [ 
			self announcer
				announce:
					(GLMTreeMorphSelectionChanged new
						selectionValue:
								((selection size = 1 and: [ self glamourPresentation isSingle ])
										ifTrue: [ selection first ]
										ifFalse: [ selection ]);
						selectionPathValue: selection;
						yourself) ]! !

!TGLMFastTable methodsFor: 'accessing - cache' stamp: 'AndreiChis 3/6/2017 11:09'!
shouldUseCache
	^ self glamourPresentation shouldUseCache! !

!TGLMFastTable methodsFor: 'selecting' stamp: 'CyrilFerlicot 12/30/2015 15:28'!
strongSelection: ann
	self announcer announce: (GLMTreeMorphStrongSelectionChanged new 
		strongSelectionValue: (self elementAt: ann selectedRowIndex);
		yourself)! !

!TGLMFastTable methodsFor: 'instance creation' stamp: 'JurajKubelka 4/10/2017 11:24'!
toString: anObject
	^ self glamourPresentation hasFilterBlock
		ifTrue: [ anObject ]
		ifFalse: [ super toString: anObject ]! !

!TGLMFastTable methodsFor: 'announcing' stamp: 'CyrilFerlicot 11/4/2015 17:12'!
when: anAnnouncementClass do: aBlock
	self announcer when: anAnnouncementClass do: aBlock! !

!TGLMFastTable methodsFor: 'announcing' stamp: 'CyrilFerlicot 11/4/2015 17:12'!
when: anAnnouncementClass send: selector to: target
	self announcer 
		when: anAnnouncementClass 
		send: selector 
		to: target! !

Trait named: #TGLMFastTableColumnsRenderer
	uses: {}
	category: 'Glamour-FastTable-Model'!

!TGLMFastTableColumnsRenderer commentStamp: 'AndreiChis 2/6/2017 14:41' prior: 0!
I am a Trait that provides methods for creating rows in a Glamour presentation with columns. I exist mainly ro provides code reuse. 

Description 
--------------------

My main entry point is #cellColumn:row:. This is the method called by FTTableMorph on a data source for obtaining the rows to display.  I can configure rows to also be editable.


Internal Representation and Key Implementation Points.
--------------------

- #rowMorphElementsForFirstColumn:item:in:    I am a  hook method for configuring the first column (tables and tree need a different first column)
- #dataFromPresentationItem:                                     I am a hook methods for getting the actual data from an item of the FTTableMorph!

!TGLMFastTableColumnsRenderer methodsFor: 'rendering' stamp: 'AndreiChis 2/5/2017 16:19'!
cellColumn: aColumn row: aRowIndex
	| item cell |
	item := self elementAt: aRowIndex.
	cell := FTCellMorph new
		cellInset: 5;
		addMorph: (self 
			rowMorphForColumn: aColumn 
			item: item 
			withIndex: aRowIndex);
		yourself.
	^ cell! !

!TGLMFastTableColumnsRenderer methodsFor: 'accessing' stamp: 'AndreiChis 2/5/2017 15:16'!
dataFromPresentationItem: anItem
	self explicitRequirement! !

!TGLMFastTableColumnsRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 3/27/2017 20:06'!
editRowMorphForColumn: glamourColumn node: aNode withIndex: aRowIndex 
	| rowMorph |

	rowMorph := self viewRowMorphForColumn: glamourColumn node: aNode withIndex: aRowIndex.
	rowMorph hResizing: #spaceFill.
	rowMorph
		on: #mouseDown
		send: #value:
		to: [ :event | 
			event shiftPressed ifTrue: [
				GLMEditorPopupBrick new
					in: [ :aPopup | aPopup themer: aPopup themer popupEditorBorderThemer themer ];
					closer: (GLMPopupBrickCloser new
						predicate: GLMPopupBrickOutisideClickPredicate new;
						predicate: GLMPopupBrickEscPredicate new;
						yourself);
					textModel: (self valueFor: aNode withIndex: aRowIndex in: glamourColumn);
					when: #textAccepted do: [ :anEvent | glamourColumn modifiedBlock
						cull: anEvent morph text
						cull: aNode
						cull: self glamourPresentation ];
					openOn: rowMorph ]
				ifFalse: [ event wasHandled: false ] ].
	
	^ rowMorph
! !

!TGLMFastTableColumnsRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 3/27/2017 20:06'!
rowMorphElementsForColumn: glamourColumn node: aNode withIndex: aRowIndex 
	| rowElements contentMorph tagMorphs |
		
	contentMorph := glamourColumn modifiedBlock
		ifNotNil: [ self editRowMorphForColumn: glamourColumn node: aNode withIndex: aRowIndex ]
		ifNil: [ self viewRowMorphForColumn: glamourColumn node: aNode withIndex: aRowIndex ].
	
	rowElements := OrderedCollection new
		add: contentMorph;
		yourself.
	
	tagMorphs := self tagMorphsFrom: glamourColumn for: aNode.
	tagMorphs ifNotEmpty: [
		rowElements addAll: tagMorphs ].
	
	^ rowElements! !

!TGLMFastTableColumnsRenderer methodsFor: 'rendering' stamp: 'AndreiChis 2/5/2017 14:47'!
rowMorphElementsForFirstColumn: aColumn item: anItem in: rowElements
	self explicitRequirement  ! !

!TGLMFastTableColumnsRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 3/27/2017 20:06'!
rowMorphForColumn: aColumn item: anItem withIndex: aRowIndex
	| rowElements |
	rowElements := OrderedCollection new.
	
	(self table columns first == aColumn) ifTrue: [
		self rowMorphElementsForFirstColumn: aColumn item: anItem in: rowElements ].
	
	rowElements
		addAll: (self 
			rowMorphElementsForColumn: aColumn glamourColumn 
			node: (self dataFromPresentationItem: anItem)
			withIndex: aRowIndex ).
		
	^ Smalltalk ui theme newRowIn: World for: rowElements! !

!TGLMFastTableColumnsRenderer methodsFor: 'accessing - cache' stamp: 'AndreiChis 3/5/2017 18:22'!
valueFor: anElement withIndex: anInteger in: aGlamourColumn
	
	^ self 
		cacheAt: aGlamourColumn title 
		for: anElement 
		ifAbsentPut: [ 
			self glamourPresentation 
				column: aGlamourColumn 
				valueFor: (self glamourPresentation isWithElementIndex
					ifTrue: [ 
						anElement asGlamorousMultiValue,
						anInteger asGlamorousMultiValue ]
			ifFalse: [ anElement ]) ]


	! !

!TGLMFastTableColumnsRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 3/27/2017 20:06'!
viewRowMorphForColumn: aGlamourColumn node: aNode withIndex: anInteger
	^ (self valueFor: aNode withIndex: anInteger in: aGlamourColumn) asMorph asReadOnlyMorph! !

Trait named: #TGLMFastTableFunctionsPresentation
	uses: {}
	category: 'Glamour-FastTable-Presentations'!

!TGLMFastTableFunctionsPresentation commentStamp: 'CyrilFerlicot 11/10/2015 10:31' prior: 0!
I am a Trait that manage the differents functionnalities for a FastTable related presentation.

Description
--------------------

My users have to define a #parameters method that need to be a getter for a Dictionary. Then I will store the informations I manage into this dictionary.

I work with all the presentations that use a FastTable as GLMFastLastPresentation, GLMFastTablePresentation or GLMFastTreePresentation.

Public API and Key Messages
--------------------

- #enableFilter 		add a filter to the GLMFastTable. (not compatible with the search)

- #enableSearch 		add a search to the GLMFastTable (A filter will remove the elements that doesn't match when a search will just highlight the matching results).
		
- #enableFilterWithAction: aBlock / #enableFilterWithAction:  aBlock named: aString 		add a filter and an action button. The action is define by a block that can take 3 parameters (the dataSource with the currents elements, the current filter pattern and the selected row of the table)
		
#searchOn: and #filterOn: are not implemented yet.

Example
--------------------

	aGLMFastTablePresentation enableFilterWithAction: [ :dataSource :pattern :item | item browse ] named: 'Browse'. 

Internal Representation and Key Implementation Points.
--------------------

To remember the options I keep some values inside a Dictionary. This dictionary is manage by a presentation and I get it via the #parameters method.!

!TGLMFastTableFunctionsPresentation classSide methodsFor: 'accessing' stamp: 'JurajKubelka 1/23/2017 20:37'!
defaultRowHeight
	^ StandardFonts defaultFont pixelSize + 7! !

!TGLMFastTableFunctionsPresentation methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 11:23'!
actionBlock
	^ self parameters at: 'actionBlock'! !

!TGLMFastTableFunctionsPresentation methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 11:42'!
actionName
	^ self parameters at: 'actionName' ifAbsent: 'Validate'! !

!TGLMFastTableFunctionsPresentation methodsFor: 'public api' stamp: 'AndreiChis 2/9/2017 23:05'!
enableElementIndex
	self parameters at: 'withRowIndex' put: true! !

!TGLMFastTableFunctionsPresentation methodsFor: 'public api' stamp: 'CyrilFerlicot 11/4/2015 11:16'!
enableFilter
	self parameters at: 'isFilterable' put: true
	! !

!TGLMFastTableFunctionsPresentation methodsFor: 'public api' stamp: 'JurajKubelka 4/10/2017 10:38'!
enableFilter: aBlock
	"aBlock receives two parameters: 
		- an item
		- a pattern.
	It should return true if the item should be displayed; false otherwise."
	self enableFilter.
	self parameters at: 'filterBlock' put: aBlock
	! !

!TGLMFastTableFunctionsPresentation methodsFor: 'public api' stamp: 'CyrilFerlicot 11/4/2015 11:41'!
enableFilterWithAction: aBlock
	self enableFilter.
	self parameters at: 'actionBlock' put: aBlock! !

!TGLMFastTableFunctionsPresentation methodsFor: 'public api' stamp: 'CyrilFerlicot 11/4/2015 11:41'!
enableFilterWithAction: aBlock named: aString
	self enableFilter.
	self parameters
		at: 'actionBlock' put: aBlock;
		at: 'actionName' put: aString! !

!TGLMFastTableFunctionsPresentation methodsFor: 'public api' stamp: 'CyrilFerlicot 11/4/2015 11:16'!
enableSearch
	self parameters at: 'isSearchable' put: true! !

!TGLMFastTableFunctionsPresentation methodsFor: 'accessing' stamp: 'JurajKubelka 4/10/2017 10:40'!
filterBlock
	^ self parameters at: 'filterBlock'! !

!TGLMFastTableFunctionsPresentation methodsFor: 'public api' stamp: 'CyrilFerlicot 11/4/2015 15:26'!
filterOn: aBlock
	self error: 'This presentation does not allow filtering with a block for now. In the futur we should have a new filter with FastTable to do that. If you want to give it a try look FTFunction and his subclasses.'! !

!TGLMFastTableFunctionsPresentation methodsFor: 'testing' stamp: 'JurajKubelka 4/10/2017 10:44'!
hasFilterBlock
	^ self parameters at: 'filterBlock' ifPresent: [ true ] ifAbsent: [ false ]! !

!TGLMFastTableFunctionsPresentation methodsFor: 'testing' stamp: 'CyrilFerlicot 11/4/2015 11:17'!
isFilterable
	^ self parameters at: 'isFilterable' ifAbsent: [ false ]! !

!TGLMFastTableFunctionsPresentation methodsFor: 'testing' stamp: 'CyrilFerlicot 11/4/2015 11:17'!
isSearchable
	^ self parameters at: 'isSearchable' ifAbsent: [ false ]! !

!TGLMFastTableFunctionsPresentation methodsFor: 'accessing' stamp: 'AndreiChis 2/9/2017 23:05'!
isWithElementIndex
	^ self parameters at: 'withRowIndex' ifAbsent: [ false ]! !

!TGLMFastTableFunctionsPresentation methodsFor: 'testing' stamp: 'CyrilFerlicot 11/4/2015 11:18'!
needActionButton
	^ self parameters at: 'actionBlock' ifPresent: [ true ] ifAbsent: [ false ]! !

!TGLMFastTableFunctionsPresentation methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 11:20'!
parameters
	self explicitRequirement! !

!TGLMFastTableFunctionsPresentation methodsFor: 'public api' stamp: 'JurajKubelka 1/23/2017 21:25'!
rowHeight
	^ self rowHeightBlock glamourValue: self asGlamorousMultiValue, self entity asGlamorousMultiValue! !

!TGLMFastTableFunctionsPresentation methodsFor: 'public api' stamp: 'JurajKubelka 1/23/2017 20:37'!
rowHeight: aNumber
	self parameters at: 'rowHeight' put: aNumber! !

!TGLMFastTableFunctionsPresentation methodsFor: 'public api' stamp: 'JurajKubelka 1/23/2017 21:26'!
rowHeightBlock
	^ self parameters 
		at: 'rowHeight'
		ifAbsent: [ self class defaultRowHeight ]! !

!TGLMFastTableFunctionsPresentation methodsFor: 'public api' stamp: 'CyrilFerlicot 11/4/2015 15:27'!
searchOn: aBlock
	self error: 'This presentation does not allow searching with a block for now. In the futur we should have a new filter with FastTable to do that. If you want to give it a try look FTFunction and his subclasses.'! !

!TGLMFastTableFunctionsPresentation methodsFor: 'public api' stamp: 'AndreiChis 3/6/2017 11:09'!
shouldUseCache
	^ self parameters 
		at: 'shouldUseCache'
		ifAbsent: [ false ]! !

!TGLMFastTableFunctionsPresentation methodsFor: 'public api' stamp: 'AndreiChis 3/6/2017 11:38'!
shouldUseCache: aBoolean
	^ self parameters 
		at: 'shouldUseCache'
		put: aBoolean! !

!TGLMFastTableFunctionsPresentation methodsFor: 'public api' stamp: 'AndreiChis 3/6/2017 11:09'!
useCache
	self parameters at: 'shouldUseCache' put: true! !

Trait named: #TGLMFastTableTag
	uses: {}
	category: 'Glamour-FastTable-Model'!

!TGLMFastTableTag commentStamp: 'CyrilFerlicot 11/10/2015 11:47' prior: 0!
I am a Trait class use to manage some basic functionnalities needed to manage tags in a Gl̂amour data source.

My user need to define the #tagToFilterBy which should return a collection of tag, then I manage some basics needs.!

!TGLMFastTableTag methodsFor: 'factory' stamp: 'CyrilFerlicot 11/9/2015 17:06'!
buttonForTag: each filter: filter
	^ (GLMMorphic togglingButtonLabelled: each pressed: (self shouldFilterByTag: filter) style: self glamourPresentation tagsStyle)
		target: self;
		actionSelector: #toggleFilteringByTag:;
		arguments: (Array with: filter);
		yourself! !

!TGLMFastTableTag methodsFor: 'private' stamp: 'CyrilFerlicot 11/9/2015 17:12'!
resetChildrenContent
	self explicitRequirement! !

!TGLMFastTableTag methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/9/2015 17:05'!
shouldFilterByTag: aTag
	^ self tagsToFilterBy includes: aTag ! !

!TGLMFastTableTag methodsFor: 'factory' stamp: 'CyrilFerlicot 11/9/2015 17:08'!
tagMorphsFrom: aTagProvider for: element
	| tagMorphs tags tagsFilter |
	
	tagMorphs := OrderedCollection new.
	tags:= self glamourPresentation tagsFor: element fromProvider: aTagProvider to: #show.
	tagsFilter := self glamourPresentation tagsFor: element fromProvider: aTagProvider to: #filter.
	tags withIndexDo:[ :each :index | 
		tagMorphs addLast: (self 
			buttonForTag: each 
			filter: (tagsFilter at: index ifAbsentPut:[ each ])) ].
	^ tagMorphs! !

!TGLMFastTableTag methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/9/2015 17:04'!
tagsToFilterBy
	self explicitRequirement! !

!TGLMFastTableTag methodsFor: 'callbacks' stamp: 'CyrilFerlicot 12/30/2015 16:03'!
toggleFilteringByTag: aTag
	(self shouldFilterByTag: aTag)
		ifTrue: [ self tagsToFilterBy remove: aTag ]
		ifFalse: [ self tagsToFilterBy add: aTag ].
	self resetChildrenContent.
	self tableRefresh! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicFTRenderer
	instanceVariableNames: 'tableModel tableMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Morphic-Renderer'!

!GLMMorphicFTRenderer commentStamp: 'CyrilFerlicot 11/10/2015 11:33' prior: 0!
I am an abstract class that define the way to render a FastTable related presentation.

Description
--------------------

I manage a FastTable dataSource and a FastTable morph. I define how to build and render them. I try to manage the maximum of the rendering and I let my subclasses define some specialities. 

My subclasses are use by a FastTable related presentation as GLMFastListPresentation or GLMFastTreePresentation. 
I use a FTTableMorph to manage the rendering and a subclass of FTDataSource to manage the data. 

Public API and Key Messages
--------------------

- #render: aPresentation 		This method is the main method of the class It allow to render myself on the presentation.
		
My subclasses should manage: 

- #createDataSourceFrom: aPresentation 		This method have to return  a new dataSource that match the presentation.
		
- #specificTableMorphInitializiation and #specificDataSourceInitializiation 		are two methods  my subclasses can override to add functionalites to the FastTable.

Internal Representation and Key Implementation Points.
--------------------

    Instance Variables
	tableModel:		Is a DataSource for Glamour that will hold the data of the presentation.
	tableMorph:		Is a FastTableMorph use to display the presentation.
!

!GLMMorphicFTRenderer methodsFor: 'callbacks' stamp: 'CyrilFerlicot 11/4/2015 14:16'!
actOnContextChanged: anAnnouncement 
	anAnnouncement property = #selection ifTrue: [ 
		tableModel announcer 
			suspendAll: self suspendedAnnouncements
			while: [ 
				tableModel explicitSelection: anAnnouncement value ] ]! !

!GLMMorphicFTRenderer methodsFor: 'callbacks' stamp: 'AndreiChis 3/5/2017 23:33'!
actOnPresentationRefreshRequest: anAnnouncement

	tableMorph window ifNil: [ ^ self ].
	tableMorph window isActive ifFalse: [ ^ self ].
	(tableMorph window boundsInWorld containsRect: tableMorph boundsInWorld) ifFalse: [ ^ self ].
  " tableModel resetElements."
	tableModel resetDataCache.
	tableMorph refresh! !

!GLMMorphicFTRenderer methodsFor: 'callbacks' stamp: 'AndreiChis 2/26/2017 22:10'!
actOnUpdatedPresentation: anAnnouncement
	tableModel resetElements.
	tableMorph refresh! !

!GLMMorphicFTRenderer methodsFor: 'adding' stamp: 'CyrilFerlicot 11/4/2015 15:01'!
addFastTableIn: container
	container addMorphBack: tableMorph! !

!GLMMorphicFTRenderer methodsFor: 'initialization' stamp: 'CyrilFerlicot 11/4/2015 14:47'!
createDataSourceFrom: aPresentation
	self subclassResponsibility! !

!GLMMorphicFTRenderer methodsFor: 'initialization' stamp: 'CyrilFerlicot 11/4/2015 15:04'!
createFastTable
	^ FTTableMorph new! !

!GLMMorphicFTRenderer methodsFor: 'private' stamp: 'TudorGirba 1/31/2016 07:46'!
dataSourceUpdated: announcement
	tableModel ifNotNil: [ self unsubscribeDataSource: tableModel ].
	tableModel := announcement newDataSource.
	self initializeAnnouncementForDataSource! !

!GLMMorphicFTRenderer methodsFor: 'private' stamp: 'AndreiChis 2/27/2017 10:21'!
initializeAnnoucementForPresentation: aPresentation
	aPresentation when: GLMDataSourceUpdated send: #dataSourceUpdated: to: self.
	aPresentation when: GLMContextChanged send: #actOnContextChanged: to: self.
	aPresentation when: GLMPresentationUpdated send: #actOnUpdatedPresentation: to: self.
	aPresentation when: GLMPresentationRefreshRequest send: #actOnPresentationRefreshRequest: to: self! !

!GLMMorphicFTRenderer methodsFor: 'private' stamp: 'JurajKubelka 4/10/2017 14:26'!
initializeAnnouncementForDataSource
	tableModel announcer
		when: GLMTreeMorphSelectionChanged
		do: [ :ann | 
			tableModel glamourPresentation announcer
				suspendAllWhile: [ 
					tableModel glamourPresentation selection: ann selectionValue.
					tableModel glamourPresentation selectionPath: ann selectionPathValue ] ].
	tableModel announcer
		when: GLMTreeMorphStrongSelectionChanged
		do: [ :ann | tableModel glamourPresentation strongSelection: ann strongSelectionValue ].
	tableMorph
		onAnnouncement: FTStrongSelectionChanged send: #strongSelection: to: tableModel;
		onAnnouncement: FTSelectionChanged send: #selection: to: tableModel.
	self installActionsOnModel: tableModel fromPresentation: tableModel glamourPresentation.
	self installKeystrokeActionsOnMorph: tableMorph fromPresentation: tableModel glamourPresentation.
! !

!GLMMorphicFTRenderer methodsFor: 'initialization' stamp: 'CyrilFerlicot 11/4/2015 14:52'!
initializeTableModel: aPresentation
	tableModel := (self createDataSourceFrom: aPresentation)
		glamourPresentation: aPresentation;
		yourself.
	self specificDataSourceInitializiation! !

!GLMMorphicFTRenderer methodsFor: 'initialization' stamp: 'AndreiChis 1/9/2016 21:15'!
initializeTableMorph
	| presentation |
	presentation := tableModel glamourPresentation.
	tableMorph := self createFastTable.
	tableMorph
		dataSource: tableModel;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		cornerStyle: tableMorph preferredCornerStyle;
		borderStyle: (BorderStyle inset width: 0);
		dragEnabled: presentation allowsItemDrag;
		dropEnabled: presentation isDropTarget;
		allowsDeselection: presentation allowsDeselection.
	self setFastTableLayoutFrame: tableMorph.
	presentation isMultiple
		ifTrue: [ tableMorph beMultipleSelection ]
		ifFalse: [ tableMorph beSingleSelection ].
	self specificTableMorphInitializiation! !

!GLMMorphicFTRenderer methodsFor: 'rendering' stamp: 'JurajKubelka 4/10/2017 15:39'!
render: aPresentation
	| container |
	container := GLMMorphic containerMorph.
	self initializeAnnoucementForPresentation: aPresentation.
	self initializeTableModel: aPresentation.
	self initializeTableMorph.
	self addFastTableIn: container.
	aPresentation selection ifNotNil: [ tableModel announcer suspendAll: self suspendedAnnouncements while: [ tableModel explicitSelection: aPresentation selection ] ].
	"No need to initialize the announcements here as setting the data source in a FTTableMorph will do it."
	"self initializeAnnouncementForDataSource."
	^ container! !

!GLMMorphicFTRenderer methodsFor: 'build ui' stamp: 'CyrilFerlicot 11/4/2015 14:37'!
setFastTableLayoutFrame: newTableMorph
	newTableMorph layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1))! !

!GLMMorphicFTRenderer methodsFor: 'initialization' stamp: 'CyrilFerlicot 11/4/2015 16:11'!
specificDataSourceInitializiation
	"Override me if you need to add something to the data source."! !

!GLMMorphicFTRenderer methodsFor: 'private' stamp: 'AndreiChis 2/5/2017 18:41'!
specificTableMorphColumnsInitialization
	| presentation |
	presentation := tableModel glamourPresentation.
	tableMorph intercellSpacing: tableModel glamourPresentation intercellSpacing.
	tableMorph beResizable.
	presentation shouldShowHeader 
		ifFalse: [ tableMorph hideColumnHeaders ]
		ifTrue: [ tableMorph showColumnHeaders ].
	tableMorph
		columns:
			(presentation columns
				collect:
					[ :each | 
					GLMFastTableColumn new
						id: (presentation titleValueOfColumn: each);
						width: each width;
						glamourColumn: each;
						target: tableModel actionSelector: #sortByColumn: arguments: {each};
						yourself ]).! !

!GLMMorphicFTRenderer methodsFor: 'initialization' stamp: 'JurajKubelka 4/10/2017 11:24'!
specificTableMorphInitializiation
	"Override me if need to add something to the tableMorph."

	| presentation |
	presentation := tableModel glamourPresentation.
	tableMorph rowHeight: presentation rowHeight.
	"I set the right function."
	presentation isSearchable
		ifTrue: [ tableMorph enableSearch ].
	presentation isFilterable
		ifTrue: [ presentation needActionButton
			ifTrue: [ tableMorph 
				enableFilterWithAction: presentation actionBlock named: presentation actionName ]
			ifFalse: [ 
				presentation hasFilterBlock 
					ifTrue: [ tableMorph enableFilter: (GLMFilterBlock block: presentation filterBlock) ]
					ifFalse: [ tableMorph enableFilter ] ] ].
	(presentation isFilterable or: [ presentation isSearchable ])
		ifFalse: [ tableMorph disableFunction ]
		ifTrue: [ tableMorph explicitFunction ]! !

!GLMMorphicFTRenderer methodsFor: 'private' stamp: 'CyrilFerlicot 11/4/2015 15:02'!
suspendedAnnouncements
	^ OrderedCollection  
		with: GLMTreeMorphSelectionChanged 
		with: GLMTreeMorphStrongSelectionChanged 
		with: GLMMenuItemSelected 
		with: GLMKeyStroke! !

!GLMMorphicFTRenderer methodsFor: 'private' stamp: 'CyrilFerlicot 11/17/2015 12:18'!
unsubscribeDataSource: aTableModel
	aTableModel announcer unsubscribe: self.
	tableMorph announcer unsubscribe: aTableModel! !

GLMMorphicFTRenderer subclass: #GLMMorphicFastListRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Morphic-Renderer'!

!GLMMorphicFastListRenderer commentStamp: 'CyrilFerlicot 11/10/2015 11:39' prior: 0!
I am a Morphic renderer for a GLMFastListPresentation.

Description
--------------------

I use a GLMFastListDataSource to manage the data of the table.
!

!GLMMorphicFastListRenderer methodsFor: 'initialization' stamp: 'CyrilFerlicot 11/10/2015 11:49'!
createDataSourceFrom: aPresentation
	^ aPresentation allowSeparators
		ifTrue: [ GLMFastListOutlineDataSource new ]
		ifFalse: [ GLMFastListDataSource new ]! !

GLMMorphicFTRenderer subclass: #GLMMorphicFastTableRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Morphic-Renderer'!

!GLMMorphicFastTableRenderer commentStamp: 'CyrilFerlicot 11/10/2015 11:39' prior: 0!
I am a Morphic renderer for a GLMFastTablePresentation.

Description
--------------------

I use a GLMFastTableDataSource to manage the data of the table.
!

!GLMMorphicFastTableRenderer methodsFor: 'initialization' stamp: 'CyrilFerlicot 11/10/2015 11:49'!
createDataSourceFrom: aPresentation
	^ GLMFastTableDataSource new! !

!GLMMorphicFastTableRenderer methodsFor: 'initialization' stamp: 'AndreiChis 2/5/2017 15:22'!
specificTableMorphInitializiation
	"Intialize first the columns and only then do the rest of the initialization."
	self specificTableMorphColumnsInitialization.
	super specificTableMorphInitializiation.
	! !

GLMMorphicFTRenderer subclass: #GLMMorphicFastTreeRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Morphic-Renderer'!

!GLMMorphicFastTreeRenderer commentStamp: 'CyrilFerlicot 11/10/2015 11:40' prior: 0!
I am a Morphic renderer for a GLMFastTreePresentation.

Description
--------------------

I use a GLMFastTreeDataSource to manage the data of the tree.
!

!GLMMorphicFastTreeRenderer methodsFor: 'initialization' stamp: 'CyrilFerlicot 11/4/2015 14:48'!
createDataSourceFrom: aPresentation
	^ GLMFastTreeDataSource new! !

!GLMMorphicFastTreeRenderer methodsFor: 'initialization' stamp: 'CyrilFerlicot 11/4/2015 16:10'!
specificDataSourceInitializiation
	| presentation |
	super specificDataSourceInitializiation.
	presentation := tableModel glamourPresentation.
	tableModel
		childrenBlock: presentation children;
		maxDepth: presentation maxDepth;
		searchStrategy: presentation strategy! !

!GLMMorphicFastTreeRenderer methodsFor: 'initialization' stamp: 'CyrilFerlicot 11/4/2015 16:12'!
specificTableMorphInitializiation
	| presentation |
	super specificTableMorphInitializiation.
	presentation := tableModel glamourPresentation.
	"If needed I extant the tree"
	presentation shouldAllExpand
		ifTrue: [ tableModel expandAll ].
	presentation shouldRootsExpand
		ifTrue: [ tableModel expandRoots ].
	presentation shouldExpandToLevel
		ifTrue: [ tableModel expandAllTo: presentation expandLevel ]! !

GLMMorphicFastTreeRenderer subclass: #GLMMorphicFastTreeWithColumnsRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Morphic-Renderer'!

!GLMMorphicFastTreeWithColumnsRenderer commentStamp: 'AndreiChis 2/6/2017 14:17' prior: 0!
I am a Morphic renderer for a GLMFastTreeTablePresentation. My main responsability is  to configure the table specific aspects of the presentation (columns, insets) and delegate to the appropriate data source.

Description
--------------------

I use a GLMFastTreeTableDataSource to manage the data of the tree with columns.
I will configure the renderer and the data source  based on a GLMFastTreeTablePresentation.
!

!GLMMorphicFastTreeWithColumnsRenderer methodsFor: 'initialization' stamp: 'AndreiChis 2/5/2017 15:01'!
createDataSourceFrom: aPresentation
	^ GLMFastTreeTableDataSource new! !

!GLMMorphicFastTreeWithColumnsRenderer methodsFor: 'initialization' stamp: 'AndreiChis 2/5/2017 18:43'!
specificTableMorphInitializiation
	self specificTableMorphColumnsInitialization.
	super specificTableMorphInitializiation.
	
! !

GLMMorphicTest subclass: #GLMMorphicFTTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Morphic-Renderer'!

!GLMMorphicFTTest methodsFor: 'asserting' stamp: 'AndreiChis 1/22/2017 13:24'!
assertNoDuplicatedAnnoucementsIn: anAnnouncement
	| duplications | 
	duplications := ((anAnnouncement subscriptions glmSubscriptions groupedBy: [ :aSubscription |
		aSubscription announcementClass ]) select: [ :each | each value size > 1 ]).
	self assert: duplications isEmpty description: 'The announcement should have only one subscription of a given type.'! !

!GLMMorphicFTTest methodsFor: 'tests' stamp: 'TudorGirba 1/30/2016 08:15'!
testNoDuplicateRegistrationOfAnnouncementsOnDataSource
	| table amountOfMenuItemSelectedSubscriptions |
	window := GLMCompositePresentation new 
			with: [ :c | 
				c fastList selectionAct: [ 42 inspect ] entitled: 'Answer' ];
			openOn: (1 to: 42).
	table := self find: FTTableMorph in: window.
	amountOfMenuItemSelectedSubscriptions := table dataSource announcer subscriptions glmSubscriptions count: [ :each | each announcementClass = GLMMenuItemSelected ].
	self assert: amountOfMenuItemSelectedSubscriptions equals: 1! !

!GLMMorphicFTTest methodsFor: 'tests' stamp: 'AndreiChis 1/22/2017 13:25'!
testNoDuplicateRegistrationsInFastTableRenderer
	| table |
	window := GLMCompositePresentation new
	  with: [ :c |
	    c fastList ];
	   openOn: (1 to: 42).

	table := self find: FTTableMorph in: window.
	self assertNoDuplicatedAnnoucementsIn: table announcer.
	self assertNoDuplicatedAnnoucementsIn: table dataSource announcer.! !

!GLMMorphicFTTest methodsFor: 'tests' stamp: 'AndreiChis 2/2/2017 19:38'!
testTypeOfMultipleSelection
	| composer firstTreeMorph treeNodeMorph |
	composer := GLMCompositePresentation new.
	composer fastList beMultiple.
	window := composer openOn: { {1} asSet . {1} asOrderedCollection }.
	firstTreeMorph := self find: FTTableMorph in: window.
	treeNodeMorph := firstTreeMorph selectionStrategy toggleRowIndex: 1.
	self assert: composer selection asOrderedCollection equals: {{1} asSet} asOrderedCollection! !

GLMListPresentation subclass: #GLMFastListPresentation
	uses: TGLMFastTableFunctionsPresentation
	instanceVariableNames: 'parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Presentations'!

!GLMFastListPresentation commentStamp: 'CyrilFerlicot 11/10/2015 10:52' prior: 0!
I'm a fast list presentation who introduces FTTableMorph into Glamour. 

Description 
-------------------

I just know how to render myself and I manage some options that the user can use for the FastTable.

The user can use almost all the functionalities of my superclass and some more. I work with a GLMMorphicFastListRenderer to render the list.  

Public API and Key Messages
-------------------

You can use the public API of my super class. You also use the public API of TGLMFastTableFunctionsPresentation (See his class comment) and you can finally use:

- #withSeparators 		I the input I receive is a collection of collection I will dispaly a list with separators between the collections.

Example
-------------------

GLMWrapper new 
	show: [ :a | 
		a fastList
			display: [ :x | 1 to: x ]];
	openOn: 1000.
	
or

GLMWrapper new 
	show: [ :a | 
		a fastList
				title: 'Example with an Outline List';
				display: [ :x | (x allSubclasses sort: [ :a :b | a asString < b asString  ]) collect: #allSubclasses  ];
				enableSearch;
				withSeparators
			];
	openOn: ProtoObject.

 
Internal Representation and Key Implementation Points.
-------------------

    Instance Variables
	parameters:		This is a Dictionary use to store some parameters of the presentation.
!

GLMFastListPresentation class
	uses: TGLMFastTableFunctionsPresentation classTrait
	instanceVariableNames: ''!

!GLMFastListPresentation methodsFor: 'testing' stamp: 'CyrilFerlicot 11/4/2015 16:31'!
allowSeparators
	^ self parameters at: 'withSeparators' ifAbsent: [ false ]! !

!GLMFastListPresentation methodsFor: 'initialize-release' stamp: 'CyrilFerlicot 11/4/2015 16:08'!
initialize
	super initialize.
	parameters := Dictionary new! !

!GLMFastListPresentation methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 16:07'!
parameters
	^ parameters! !

!GLMFastListPresentation methodsFor: 'rendering' stamp: 'EstebanLorenzano 6/18/2015 12:01'!
renderGlamorouslyOn: aRenderer 
	self registerAnnouncements.
	^ aRenderer renderFastListPresentation: self! !

!GLMFastListPresentation methodsFor: 'public api' stamp: 'CyrilFerlicot 11/4/2015 16:31'!
withSeparators
	self parameters at: 'withSeparators' put: true! !

FTColumn subclass: #GLMFastTableColumn
	instanceVariableNames: 'glamourColumn target selector arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Model'!

!GLMFastTableColumn commentStamp: '<historical>' prior: 0!
I'm a glamour column for fast tables.!

!GLMFastTableColumn methodsFor: 'execute' stamp: 'EstebanLorenzano 6/17/2015 13:13'!
execute 
	target ifNil: [ ^ self ].
	selector ifNil: [ ^ self ].
	
	target perform: selector withArguments: arguments! !

!GLMFastTableColumn methodsFor: 'accessing' stamp: 'EstebanLorenzano 6/13/2015 14:51'!
glamourColumn
	^ glamourColumn! !

!GLMFastTableColumn methodsFor: 'accessing' stamp: 'EstebanLorenzano 6/13/2015 14:51'!
glamourColumn: anObject
	glamourColumn := anObject! !

!GLMFastTableColumn methodsFor: 'accessing' stamp: 'EstebanLorenzano 6/16/2015 21:30'!
target: aTarget actionSelector: aSelector arguments: aCollection 
	target := aTarget. 
	selector := aSelector.
	arguments := aCollection! !

FTOutlineDataSource subclass: #GLMFastListOutlineDataSource
	uses: TGLMFastTable + TGLMFastTableTag
	instanceVariableNames: 'announcer glamourPresentation tagsToFilterBy dataCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Model'!

!GLMFastListOutlineDataSource commentStamp: 'CyrilFerlicot 11/10/2015 11:59' prior: 0!
I'm a model datasource to handle glamour fast outline list presentations.

Description 
--------------------

My basics functionnalities works as in my superclass but I do not get my data at my creation. Instead I ask to my Glamour presentation to get them.

I work with a GLMFastListPresentation and a GLMMorphicFastListRenderer. 

Internal Representation and Key Implementation Points.
--------------------

    Instance Variables
	announcer:		This is an announcer use to work with Glamour workflow. 
	glamourPresentation:		This is a glamour presentation use to get some informations as the data manage by myself.
	tagsToFilterBy:		This is a list of filtering tags for the dasaSource.

!

GLMFastListOutlineDataSource class
	uses: TGLMFastTable classTrait + TGLMFastTableTag classTrait
	instanceVariableNames: ''!

!GLMFastListOutlineDataSource methodsFor: 'announcing' stamp: 'CyrilFerlicot 11/4/2015 17:42'!
announcer
	^ announcer ifNil: [ announcer := GLMAnnouncer new ]! !

!GLMFastListOutlineDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/9/2015 10:54'!
basicItems
	^ self glamourPresentation displayValue! !

!GLMFastListOutlineDataSource methodsFor: 'accessing' stamp: 'JurajKubelka 12/26/2016 12:00'!
calculateItems
	^ self basicItems collect: [:coll | coll select: [ :each | self elementShouldBeDisplayed: each ] ]! !

!GLMFastListOutlineDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/16/2015 10:39'!
cellColumn: column row: rowIndex 
	| element cell |
	
	element := self elementAt: rowIndex.
	cell := FTCellMorph new
		cellInset: 5;
		addMorph: (self rowMorphForElement: element);
		yourself.

	(self needSeparatorBefore: rowIndex)
		ifTrue: [ cell withTopSeparator ].

	^ cell! !

!GLMFastListOutlineDataSource methodsFor: 'cache' stamp: 'AndreiChis 3/6/2017 11:43'!
dataCache
	^ dataCache ifNil: [ dataCache := self class defaultCache ]! !

!GLMFastListOutlineDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/9/2015 10:49'!
glamourPresentation
	^ glamourPresentation! !

!GLMFastListOutlineDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/9/2015 10:50'!
glamourPresentation: aGlamourPresentation
	glamourPresentation := aGlamourPresentation! !

!GLMFastListOutlineDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/9/2015 10:52'!
items 
	^ items ifNil: [ items := self calculateItems ]! !

!GLMFastListOutlineDataSource methodsFor: 'private' stamp: 'AndreiChis 3/6/2017 11:45'!
resetChildrenContent
	items := self calculateItems.
	self resetDataCache! !

!GLMFastListOutlineDataSource methodsFor: 'cache' stamp: 'AndreiChis 3/6/2017 11:17'!
resetDataCache
	dataCache := nil! !

!GLMFastListOutlineDataSource methodsFor: 'accessing' stamp: 'AndreiChis 10/19/2017 16:44'!
resetElements
	self resetDataCache.
	self items: nil! !

!GLMFastListOutlineDataSource methodsFor: 'factory' stamp: 'AndreiChis 3/5/2017 18:32'!
rowMorphForElement: element
	| rowElements |
	rowElements := OrderedCollection new.
	(self iconFor: element) ifNotNil: [ :icon | rowElements add: icon asMorph ].
	rowElements
		add: (self formatedDisplayValueOf: element) asMorph;
		addAll: (self tagMorphsFrom: self glamourPresentation for: element).
	^ Smalltalk ui theme newRowIn: World for: rowElements! !

!GLMFastListOutlineDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/9/2015 16:05'!
tagsToFilterBy
	^ tagsToFilterBy ifNil: [ tagsToFilterBy := OrderedCollection new ]! !

!GLMMorphicRenderer methodsFor: '*Glamour-FastTable' stamp: 'EstebanLorenzano 6/18/2015 12:00'!
renderFastListPresentation: aPresentation 
	^ GLMMorphicFastListRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: '*Glamour-FastTable' stamp: 'EstebanLorenzano 6/12/2015 17:33'!
renderFastTablePresentation: aPresentation 
	^ GLMMorphicFastTableRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: '*Glamour-FastTable' stamp: 'CyrilFerlicot 11/3/2015 14:38'!
renderFastTreePresentation: aPresentation 
	^ GLMMorphicFastTreeRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: '*Glamour-FastTable' stamp: 'AndreiChis 2/5/2017 15:04'!
renderFastTreeWithColumnsPresentation: aPresentation 
	^ GLMMorphicFastTreeWithColumnsRenderer render: aPresentation from: self! !

!GLMCompositePresentation methodsFor: '*Glamour-FastTable' stamp: 'EstebanLorenzano 6/18/2015 11:58'!
fastList
	^ self custom: GLMFastListPresentation new! !

!GLMCompositePresentation methodsFor: '*Glamour-FastTable' stamp: 'EstebanLorenzano 6/12/2015 18:05'!
fastTable
	^ self custom: GLMFastTablePresentation new! !

!GLMCompositePresentation methodsFor: '*Glamour-FastTable' stamp: 'CyrilFerlicot 11/3/2015 14:35'!
fastTree
	^ self custom: GLMFastTreePresentation new! !

!GLMCompositePresentation methodsFor: '*Glamour-FastTable' stamp: 'AndreiChis 2/5/2017 15:26'!
fastTreeTable
	^ self custom: GLMFastTreeTablePresentation new! !

FTSimpleDataSource subclass: #GLMFastListDataSource
	uses: TGLMFastTable + TGLMFastTableTag
	instanceVariableNames: 'glamourPresentation announcer tagsToFilterBy dataCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Model'!

!GLMFastListDataSource commentStamp: 'CyrilFerlicot 11/10/2015 11:59' prior: 0!
I'm a model datasource to handle glamour fast list presentations.

Description 
--------------------

My basics functionnalities works as in my superclass but I do not get my data at my creation. Instead I ask to my Glamour presentation to get them.

I work with a GLMFastListPresentation and a GLMMorphicFastListRenderer. 

Internal Representation and Key Implementation Points.
--------------------

    Instance Variables
	announcer:		This is an announcer use to work with Glamour workflow. 
	glamourPresentation:		This is a glamour presentation use to get some informations as the data manage by myself.
	tagsToFilterBy:		This is a list of filtering tags for the dasaSource.

!

GLMFastListDataSource class
	uses: TGLMFastTable classTrait + TGLMFastTableTag classTrait
	instanceVariableNames: ''!

!GLMFastListDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 16:42'!
actionColumn: column
	"If columns has actions associated, execute them"
	column execute.
	self tableRefresh! !

!GLMFastListDataSource methodsFor: 'announcing' stamp: 'CyrilFerlicot 11/4/2015 16:42'!
announcer
	^ announcer ifNil: [ announcer := GLMAnnouncer new ]! !

!GLMFastListDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/16/2015 10:37'!
cellColumn: column row: rowIndex
	| element cell |
	element := self elementAt: rowIndex.
	cell := FTCellMorph new
		cellInset: 5;
		addMorph: (self rowMorphForElement: element);
		yourself.
	^ cell! !

!GLMFastListDataSource methodsFor: 'cache' stamp: 'AndreiChis 3/6/2017 11:43'!
dataCache
	^ dataCache ifNil: [ dataCache := self class defaultCache ]! !

!GLMFastListDataSource methodsFor: 'drag and drop' stamp: 'CyrilFerlicot 11/4/2015 16:42'!
dragTransferType
	^ #Glamour! !

!GLMFastListDataSource methodsFor: 'drag and drop' stamp: 'CyrilFerlicot 11/4/2015 16:42'!
dropElements: aCollection index: rowIndex
	self glamourPresentation 
		accept: (self collectionToDragPassenger: aCollection)
		droppedOnItem: (self elementOrZeroAt: rowIndex)! !

!GLMFastListDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 16:42'!
elements
	^ elements ifNil: [ elements := self calculateElements ]! !

!GLMFastListDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 16:42'!
glamourPresentation
	^ glamourPresentation! !

!GLMFastListDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 16:42'!
glamourPresentation: anObject
	glamourPresentation := anObject! !

!GLMFastListDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 16:42'!
headerColumn: column
	column id ifNil: [ ^ nil ].
	^ SimpleButtonMorph new
		layoutPolicy: RowLayout new; 
		listDirection: #leftToRight; 
		wrapCentering: #center;
		cellInset: 5@0;
		layoutInset: 5@0;
		label: column id;
		target: self;
		actionSelector: #actionColumn:;
		arguments: {column};
		yourself! !

!GLMFastListDataSource methodsFor: 'private' stamp: 'AndreiChis 3/6/2017 11:44'!
resetChildrenContent
	elements := self calculateElements.
	self resetDataCache! !

!GLMFastListDataSource methodsFor: 'cache' stamp: 'AndreiChis 3/6/2017 11:10'!
resetDataCache
	dataCache := nil! !

!GLMFastListDataSource methodsFor: 'accessing' stamp: 'AndreiChis 3/5/2017 21:55'!
resetElements
	self resetDataCache.
	elements := nil! !

!GLMFastListDataSource methodsFor: 'factory' stamp: 'AndreiChis 3/5/2017 18:32'!
rowMorphForElement: element
	| rowElements |
	rowElements := OrderedCollection new.
	(self iconFor: element) ifNotNil: [ :icon | rowElements add: icon asMorph ].
	rowElements
		add: (self formatedDisplayValueOf: element) asMorph asReadOnlyMorph;
		addAll: (self tagMorphsFrom: self glamourPresentation for: element).
	^ Smalltalk ui theme newRowIn: World for: rowElements! !

!GLMFastListDataSource methodsFor: 'selecting' stamp: 'CyrilFerlicot 12/23/2015 11:47'!
selectTable: aTable element: anObject 
	aTable selectRowIndex: (self elements indexOf: anObject)! !

!GLMFastListDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 16:42'!
tagsToFilterBy
	^ tagsToFilterBy ifNil: [ tagsToFilterBy := OrderedCollection new ]! !

!GLMFastListDataSource methodsFor: 'drag and drop' stamp: 'CyrilFerlicot 11/4/2015 17:10'!
wantsDropElements: aCollection type: type index: rowIndex
	^ (aCollection isEmptyOrNil or: [ type ~= self dragTransferType ])
		ifFalse: [ self glamourPresentation allow: (self collectionToDragPassenger: aCollection) droppedOnItem: (self elementOrZeroAt: rowIndex) ]
		ifTrue: [ false ]! !

GLMFastListDataSource subclass: #GLMFastTableDataSource
	uses: TGLMFastTableColumnsRenderer
	instanceVariableNames: 'columnToSortBy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Model'!

!GLMFastTableDataSource commentStamp: 'AndreiChis 2/6/2017 14:39' prior: 0!
I'm a model datasource to handle glamour fast table presentations.

Description 
--------------------

I am a GLMFastListDataSource that can also manage multi columns.

I work with a GLMFastTablePresentation and a GLMMorphicFastTableRenderer.  

 I rely on TGLMFastTableColumnsRenderer for the logic that actually builds the row morphs. 
!

GLMFastTableDataSource class
	uses: TGLMFastTableColumnsRenderer classTrait
	instanceVariableNames: ''!

!GLMFastTableDataSource methodsFor: 'as yet unclassified' stamp: 'AndreiChis 2/5/2017 15:16'!
dataFromPresentationItem: anItem
	^ anItem! !

!GLMFastTableDataSource methodsFor: 'private' stamp: 'CyrilFerlicot 10/6/2015 16:58'!
elementsSorted
	elements ifNil: [ ^ nil ].
	^ columnToSortBy 
		ifNotNil: [ elements sorted: self sortBlock ]
		ifNil: [ self calculateElements ]! !

!GLMFastTableDataSource methodsFor: 'accessing' stamp: 'AndreiChis 3/5/2017 18:26'!
rowMorphElementsForFirstColumn: aColumn item: anItem in: rowElements
	
	(self iconFor: anItem) ifNotNil: [ :anIcon | rowElements add: anIcon asMorph ] ! !

!GLMFastTableDataSource methodsFor: 'private' stamp: 'EstebanLorenzano 6/16/2015 21:35'!
sortBlock
	^ columnToSortBy sortBlock ifNil: [ 
		columnToSortBy defaultSortBlockForPresentation: self glamourPresentation ]! !

!GLMFastTableDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 10/6/2015 16:59'!
sortByColumn: aGlamourColumn
	columnToSortBy := (columnToSortBy == aGlamourColumn 
		ifTrue: [ nil ]
		ifFalse: [ aGlamourColumn ]).
	elements := self elementsSorted.
	self glamourPresentation changed.! !

GLMTablePresentation subclass: #GLMFastTablePresentation
	uses: TGLMFastTableFunctionsPresentation
	instanceVariableNames: 'parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Presentations'!

!GLMFastTablePresentation commentStamp: 'CyrilFerlicot 11/10/2015 10:58' prior: 0!
I'm a fast table presentation who introduces FTTableMorph into Glamour. 

Description
--------------------

I know how to render myself and I store some options for the Table.  I keep some options specific to the FastTable inside a Dictionary. 

I work with GLMMorphicFastTableRenderer to render the FastTable. I use TGLMFastTableFunctionsPresentation in order to manage some options.

Public API and Key Messages
--------------------

You can use the public API of my super class. You also use the public API of TGLMFastTableFunctionsPresentation (See his class comment).

For now I do not add any other api methods.

Example
--------------------

GLMWrapper new 
	show: [ :a | 
		a fastTable
			display: [ :x | 1 to: x ]; 
			column: [:x | 'Numbers from 1 to ', x asString] evaluated: #asString;
			column: 'Even' evaluated: [ :each | each even asString ];
			column: 'Odd' evaluated: [ :each | each odd asString ]  ];
	openOn: 1000.

Internal Representation and Key Implementation Points.
--------------------

    Instance Variables
	parameters:		This is a Dictionary use to store some options related to the FastTable.
!

GLMFastTablePresentation class
	uses: TGLMFastTableFunctionsPresentation classTrait
	instanceVariableNames: ''!

!GLMFastTablePresentation methodsFor: 'accessing' stamp: 'AndreiChis 2/5/2017 14:19'!
children: anObject 
	 
	self shouldNotImplement ! !

!GLMFastTablePresentation methodsFor: 'initialization' stamp: 'CyrilFerlicot 11/4/2015 16:08'!
initialize
	super initialize.
	parameters := Dictionary new! !

!GLMFastTablePresentation methodsFor: 'public api' stamp: 'EstebanLorenzano 11/29/2016 11:15'!
intercellSpacing
	^ self parameters 
		at: 'intercellSpacing' 
		ifAbsent: [ self class defaultIntercellSpacing ]! !

!GLMFastTablePresentation methodsFor: 'public api' stamp: 'AndreiChis 1/18/2016 19:14'!
intercellSpacing: aNumber
	self parameters at: 'intercellSpacing' put: aNumber! !

!GLMFastTablePresentation methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 16:08'!
parameters
	^ parameters! !

!GLMFastTablePresentation methodsFor: 'rendering' stamp: 'EstebanLorenzano 6/12/2015 17:22'!
renderGlamorouslyOn: aRenderer 
	self registerAnnouncements.
	^ aRenderer renderFastTablePresentation: self! !

FTTreeDataSource subclass: #GLMFastTreeDataSource
	uses: TGLMFastTable + TGLMFastTableTag
	instanceVariableNames: 'glamourPresentation announcer tagsToFilterBy dataCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Model'!

!GLMFastTreeDataSource commentStamp: 'CyrilFerlicot 11/10/2015 11:59' prior: 0!
I'm a model datasource to handle glamour fast tree presentations.

Description 
--------------------

My basics functionnalities works as in my superclass but I do not get my data at my creation. Instead I ask to my Glamour presentation to get them.

I work with a GLMFastTreePresentation and a GLMMorphicFastTreeRenderer. 

Internal Representation and Key Implementation Points.
--------------------

    Instance Variables
	announcer:		This is an announcer use to work with Glamour workflow. 
	glamourPresentation:		This is a glamour presentation use to get some informations as the data manage by myself.
	tagsToFilterBy:		This is a list of filtering tags for the dasaSource.

!

GLMFastTreeDataSource class
	uses: TGLMFastTable classTrait + TGLMFastTableTag classTrait
	instanceVariableNames: ''!

!GLMFastTreeDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/3/2015 15:12'!
announcer
	^ announcer ifNil: [ announcer := GLMAnnouncer new ]! !

!GLMFastTreeDataSource methodsFor: 'private' stamp: 'CyrilFerlicot 11/3/2015 15:06'!
basicRoots
	^ self glamourPresentation displayValue! !

!GLMFastTreeDataSource methodsFor: 'accessing' stamp: 'AndreiChis 2/5/2017 13:44'!
buttonFor: item
	^ ( (self canDisplayChildrenOf: item) and: [self hasChildren: item])
		ifTrue: [ item generateButton ]
		ifFalse: [ self class emptyMorph ]! !

!GLMFastTreeDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/16/2015 10:27'!
cellColumn: aColumnIndex row: aRowIndex
	| item cell |
	item := self elementAt: aRowIndex.
	cell := FTCellMorph new
		cellInset: 5;
		addMorph: (self rowMorphForItem: item);
		yourself.
	^ cell! !

!GLMFastTreeDataSource methodsFor: 'private' stamp: 'AndreiChis 2/5/2017 17:33'!
createRootItem
	| fullRoot |
	fullRoot := FTRootItem data: self basicRoots from: self.
	^ self tagsToFilterBy
		ifEmpty: [ fullRoot ]
		ifNotEmpty:
			[ | children |
			children := OrderedCollection new.
			fullRoot children
				do: [ :item | (self matchingTag: item) ifNotNil: [ :itemNew | children add: itemNew ] ]
				displayingProgress: [ :each | 'Looking inside ' , each printString ].
			FTRootItem new
				dataSource: self;
				children: children asArray;
				yourself ]! !

!GLMFastTreeDataSource methodsFor: 'cache' stamp: 'AndreiChis 3/6/2017 11:44'!
dataCache
	^ dataCache ifNil: [ dataCache := self class defaultCache ]! !

!GLMFastTreeDataSource methodsFor: 'selecting' stamp: 'CyrilFerlicot 1/5/2016 12:31'!
explicitSelection: anObject
	self table selectRowIndexes: (self searchText: anObject asString)! !

!GLMFastTreeDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/3/2015 14:59'!
glamourPresentation
	^ glamourPresentation! !

!GLMFastTreeDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 10:31'!
glamourPresentation: aGLMFastTreePresentation
	glamourPresentation := aGLMFastTreePresentation! !

!GLMFastTreeDataSource methodsFor: 'testing' stamp: 'AndreiChis 2/5/2017 13:44'!
hasChildren: anItem
	^ self glamourPresentation hasChildrenBlock 
		ifNil: [ anItem children isNotEmpty ]
		ifNotNil: [ :aBlock | aBlock cull: anItem data ]! !

!GLMFastTreeDataSource methodsFor: 'tag' stamp: 'CyrilFerlicot 12/30/2015 16:01'!
matchingTag: anItem
	| elementTags |
	elementTags := self glamourPresentation tagsFor: anItem data to: #filter.
	((anItem children collect: [ :it | self matchingTag: it ]) reject: #isNil)
		ifNotEmpty: [ :coll | 
			^ (self newStaticItemFrom: anItem)
				children: coll asArray;
				yourself ].
	^ (self tagsToFilterBy allSatisfy: [ :each | elementTags includes: each ])
		ifFalse: [ nil ]
		ifTrue: [ self newStaticItemFrom: anItem ]! !

!GLMFastTreeDataSource methodsFor: 'instance creation' stamp: 'CyrilFerlicot 11/9/2015 16:00'!
newStaticItemFrom: anItem
	^ FTStaticBasicItem new
		data: anItem data;
		depth: anItem depth;
		children: #();
		dataSource: self;
		yourself! !

!GLMFastTreeDataSource methodsFor: 'private' stamp: 'AndreiChis 3/6/2017 11:44'!
resetChildrenContent
	self rootItem: self createRootItem.
	self resetDataCache! !

!GLMFastTreeDataSource methodsFor: 'cache' stamp: 'AndreiChis 3/6/2017 11:44'!
resetDataCache
	dataCache := nil! !

!GLMFastTreeDataSource methodsFor: 'accessing' stamp: 'AndreiChis 3/5/2017 21:55'!
resetElements
	self resetDataCache.
	self updateData! !

!GLMFastTreeDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/3/2015 15:04'!
rootItem
	^ rootItem ifNil: [ rootItem := self createRootItem ]! !

!GLMFastTreeDataSource methodsFor: 'private' stamp: 'AndreiChis 3/5/2017 18:32'!
rowMorphForItem: anItem
	| rowElements |
	rowElements := OrderedCollection new.
	anItem depth timesRepeat: [ rowElements add: self class emptyMorph ].
	rowElements add: (self buttonFor: anItem).
	(self iconFor: anItem data) ifNotNil: [ :icon | rowElements add: icon asMorph ].
	rowElements
		add: (self formatedDisplayValueOf: anItem data) asMorph asReadOnlyMorph;
		addAll: (self tagMorphsFrom: self glamourPresentation for: anItem data).
	^ Smalltalk ui theme newRowIn: World for: rowElements! !

!GLMFastTreeDataSource methodsFor: 'selecting' stamp: 'AndreiChis 2/9/2017 22:25'!
selection: ann
	| selection |
	selection := ann newSelectedRowIndexes
		select: [ :each | each ~= 0 ]
		thenCollect: [ :each | (self elementAt: each) data ].
	selection
		ifNotEmpty: [ 
			self announcer
				announce:
					(GLMTreeMorphSelectionChanged new
						selectionValue:
								((selection size = 1 and: [ self glamourPresentation isSingle ])
										ifTrue: [ selection first ]
										ifFalse: [ selection ]);
						selectionPathValue: selection;
						yourself) ]! !

!GLMFastTreeDataSource methodsFor: 'selecting' stamp: 'CyrilFerlicot 12/30/2015 15:30'!
strongSelection: ann
	self announcer
		announce:
			(GLMTreeMorphStrongSelectionChanged new
				strongSelectionValue: (self elementAt: ann selectedRowIndex) data;
				yourself)! !

!GLMFastTreeDataSource methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/9/2015 15:18'!
tagsToFilterBy
	^ tagsToFilterBy ifNil: [ tagsToFilterBy := OrderedCollection new ]! !

GLMFastTreeDataSource subclass: #GLMFastTreeTableDataSource
	uses: TGLMFastTableColumnsRenderer
	instanceVariableNames: 'columnToSortBy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Model'!

!GLMFastTreeTableDataSource commentStamp: 'AndreiChis 2/6/2017 14:44' prior: 0!
I'm a model datasource to add columns support to a tree presentation.

Description 
--------------------

My superclass models a tree. I override  #cellColumn:row: to return a row that contains multiple columns.

I work with a GLMFastTreeTablePresentation and a GLMMorphicFastTreeWithColumnsRenderer.  I rely on TGLMFastTableColumnsRenderer for the logic that actually builds the row morphs. 

Internal Representation and Key Implementation Points.
--------------------

- #rowMorphElementsForFirstColumn:item:in:    I configure the first column with the propper indentation and buttons for expanding collapsing the node.
- #dataFromPresentationItem:                                     I return the data from the given item

    Instance Variables
	columnToSortBy		This is the column to use for sorting the displayed elements

!

GLMFastTreeTableDataSource class
	uses: TGLMFastTableColumnsRenderer classTrait
	instanceVariableNames: ''!

!GLMFastTreeTableDataSource methodsFor: 'accessing' stamp: 'AndreiChis 2/5/2017 17:41'!
actionColumn: column
	"If columns has actions associated, execute them"
	column execute.
	self tableRefresh! !

!GLMFastTreeTableDataSource methodsFor: 'accessing' stamp: 'AndreiChis 2/5/2017 15:16'!
dataFromPresentationItem: anItem
	^ anItem data! !

!GLMFastTreeTableDataSource methodsFor: 'accessing' stamp: 'TravisCI 12/11/2016 23:13'!
headerColumn: column
	column id ifNil: [ ^ nil ].
	^ SimpleButtonMorph new
		layoutPolicy: RowLayout new; 
		listDirection: #leftToRight; 
		wrapCentering: #center;
		cellInset: 5@0;
		layoutInset: 5@0;
		label: column id;
		target: self;
		actionSelector: #actionColumn:;
		arguments: {column};
		yourself! !

!GLMFastTreeTableDataSource methodsFor: 'accessing' stamp: 'AndreiChis 3/5/2017 18:05'!
rowMorphElementsForFirstColumn: aColumn item: anItem in: rowElements

	anItem depth timesRepeat: [ rowElements add: self class emptyMorph ].
	rowElements add: (self buttonFor: anItem).
	(self iconFor: anItem data) ifNotNil: [ :icon | rowElements add: icon asMorph ].! !

!GLMFastTreeTableDataSource methodsFor: 'sorting' stamp: 'AndreiChis 2/5/2017 18:00'!
sortBlock
	^  columnToSortBy sortBlock ifNil: [ |defaultSortBlock|
			defaultSortBlock := columnToSortBy defaultSortBlockForPresentation: self glamourPresentation.
		 	[ :x :y | defaultSortBlock value: x data value: y data ] ]! !

!GLMFastTreeTableDataSource methodsFor: 'sorting' stamp: 'AndreiChis 2/5/2017 18:14'!
sortByColumn: aGlamourColumn
	columnToSortBy := (columnToSortBy == aGlamourColumn 
		ifTrue: [ nil ]
		ifFalse: [ aGlamourColumn ]).
		
	columnToSortBy 
		ifNotNil: [ self rootItem children: (self rootItem children sorted: self sortBlock) ]
		ifNil: [ self rootItem data: self basicRoots ].

	self glamourPresentation changed.! !

GLMTreePresentation subclass: #GLMFastTreePresentation
	uses: TGLMFastTableFunctionsPresentation
	instanceVariableNames: 'parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Presentations'!

!GLMFastTreePresentation commentStamp: 'CyrilFerlicot 11/10/2015 14:06' prior: 0!
I'm a fast table presentation who introduces FTTableMorph into Glamour  as a Tree. 

Description
--------------------

I know how to render myself and I store some options for the Tree.  I keep some options specific to the FastTable inside a Dictionary. 

I work with GLMMorphicFastTreeRenderer to render the FastTable. I use TGLMFastTableFunctionsPresentation in order to manage some options.

Public API and Key Messages
--------------------

You can use the public API of my super class. You also use the public API of TGLMFastTableFunctionsPresentation (See his class comment) and you can also use:

- #maxDepth: anInteger 		to define a max depth for the tree.   
		
- #expandedUntil: aDepth 		this is use to expand the tree at the opening until a certain depth.
		 
- #strategy: aSymbole 		this is use to define a Strategy for the search or the filter inside a Tree. I can take in parameter #default, #rootsOnly, #allItems.
                #default is selected by default, it will search/filter the tree for all visible rows.       
               #rootsOnly will search/filter only the first level of the tree
               #allItems will search/filter all the Tree and open the needed items. Do not use this if the tree is not finish.

Example
--------------------

	GLMWrapper new
		show:
				[ :a | 
			a fastTree
				children: [ :x | x subclasses ];
				enableFilterWithAction: [ :dataSource :pattern :item | item browse ];
				strategy: #rootsOnly;
				maxDepth: 3;
				rootsExpanded ];
		openOn: (Object subclasses) asArray
 
Internal Representation and Key Implementation Points.
--------------------

    Instance Variables
	parameters:		This is a Dictionary use to store some parameters of the presentation.
!

GLMFastTreePresentation class
	uses: TGLMFastTableFunctionsPresentation classTrait
	instanceVariableNames: ''!

!GLMFastTreePresentation methodsFor: 'public api' stamp: 'CyrilFerlicot 11/10/2015 14:06'!
expandedUntil: anInteger
	self shouldExpandToLevel: anInteger! !

!GLMFastTreePresentation methodsFor: 'public api' stamp: 'AndreiChis 2/5/2017 13:48'!
hasChildren: aBlock
	self parameters at: 'hasChildrenBlock' put: aBlock! !

!GLMFastTreePresentation methodsFor: 'accessing' stamp: 'AndreiChis 2/5/2017 13:48'!
hasChildrenBlock 
	^ self parameters at: 'hasChildrenBlock' ifAbsent: [ nil ]! !

!GLMFastTreePresentation methodsFor: 'initialize-release' stamp: 'CyrilFerlicot 11/4/2015 11:02'!
initialize
	super initialize.
	parameters := Dictionary new! !

!GLMFastTreePresentation methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 16:25'!
maxDepth
	^ self parameters at: 'maxDepth' ifAbsent: [ nil ]! !

!GLMFastTreePresentation methodsFor: 'public api' stamp: 'CyrilFerlicot 11/4/2015 16:26'!
maxDepth: anInteger
	self parameters at: 'maxDepth' put: anInteger! !

!GLMFastTreePresentation methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 11:03'!
parameters
	^ parameters! !

!GLMFastTreePresentation methodsFor: 'rendering' stamp: 'CyrilFerlicot 11/3/2015 14:37'!
renderGlamorouslyOn: aRenderer 
	self registerAnnouncements.
	^ aRenderer renderFastTreePresentation: self! !

!GLMFastTreePresentation methodsFor: 'accessing' stamp: 'CyrilFerlicot 11/4/2015 16:23'!
strategy
	^ self parameters at: 'strategy' ifAbsent: [ #default ]! !

!GLMFastTreePresentation methodsFor: 'public api' stamp: 'CyrilFerlicot 11/4/2015 16:23'!
strategy: aSymbole
	self parameters at: 'strategy' put: aSymbole! !

GLMFastTreePresentation subclass: #GLMFastTreeTablePresentation
	uses: TGLMScriptingAPITablePresentation
	instanceVariableNames: 'columns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Presentations'!

!GLMFastTreeTablePresentation commentStamp: 'AndreiChis 2/6/2017 14:28' prior: 0!
I'm a fast table presentation who introduces FTTableMorph into Glamour  as a Tree that can have columns. 

Description
--------------------

I know how to render myself and I store some options for the building a tree and for displaying multiple columns .  

I work with GLMMorphicFastTreeWithColumnsRenderer to render the FastTable. I use TGLMScriptingAPITablePresentation in order to adding the API for configuring columns. 

Public API and Key Messages
--------------------

You can use the public API of my super class. You also use the public API of TGLMScriptingAPITablePresentation (See his class comment).

Example
--------------------
	
	| browser |
	browser := GLMTabulator new.
	browser row: #Example.
	browser transmit
		to: #Example;
		andShow: [ :a | a fastTreeTable 
			children: [ :x | 1 to: x-1 ];
			column: [:x | 'Numbers from 1 to ', x asString] evaluated: #asString;
			column: 'Even' evaluated: [ :each | each even asString ];
			column: 'Odd' evaluated: [ :each | each odd asString ];
			icon: [ :each | 
				each asInteger odd
					ifTrue: [ GLMUIThemeExtraIcons glamorousRedCircle ]
					ifFalse: [ GLMUIThemeExtraIcons glamorousGreenCircle ] ] ].
	browser openOn: (1 to: 10)

Internal Representation and Key Implementation Points.
--------------------

    Instance Variables
	columns:		This is an OrderedCollection storing the columns that will be rendered by this presentation.
!

GLMFastTreeTablePresentation class
	uses: TGLMScriptingAPITablePresentation classTrait
	instanceVariableNames: ''!

!GLMFastTreeTablePresentation methodsFor: 'accessing' stamp: 'AndreiChis 2/5/2017 14:15'!
columns
	^ columns ifNil: [ columns := OrderedCollection new ]! !

!GLMFastTreeTablePresentation methodsFor: 'scripting' stamp: 'AndreiChis 2/5/2017 14:16'!
hideHeader
	^ self parameters at: 'shouldShowHeader' put: [ false ]! !

!GLMFastTreeTablePresentation methodsFor: 'scripting' stamp: 'AndreiChis 2/5/2017 15:33'!
intercellSpacing
	^ self parameters 
		at: 'intercellSpacing' 
		ifAbsent: [ self class defaultIntercellSpacing ]! !

!GLMFastTreeTablePresentation methodsFor: 'scripting' stamp: 'AndreiChis 2/5/2017 15:33'!
intercellSpacing: aNumber
	self parameters at: 'intercellSpacing' put: aNumber! !

!GLMFastTreeTablePresentation methodsFor: 'rendering' stamp: 'AndreiChis 2/5/2017 14:59'!
renderGlamorouslyOn: aRenderer 
	self registerAnnouncements.
	^ aRenderer renderFastTreeWithColumnsPresentation: self! !

!GLMFastTreeTablePresentation methodsFor: 'accessing' stamp: 'AndreiChis 2/5/2017 14:16'!
shouldShowHeader
	^ self parameters at: 'shouldShowHeader' ifAbsent: [ true ]! !

Announcement subclass: #GLMDataSourceUpdated
	instanceVariableNames: 'newDataSource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Announcement'!

!GLMDataSourceUpdated commentStamp: 'CyrilFerlicot 11/16/2015 15:51' prior: 0!
I am an annoucement use by Glamour to signal that the dataSource of a Renderer changed.

Description 
--------------------

I keep a pointer to the new dataSource. 
I can be use when the user filter a FastTable for example.
I am use by a Fast related renderer in GLMMorphicFTRenderer.

Public API and Key Messages
------------------

- newDataSource: aDataSource 		is my constructor.
		
Internal Representation and Key Implementation Points.
------------------ 

    Instance Variables
	newDataSource:		The new DataSource.
!

!GLMDataSourceUpdated class methodsFor: 'instance creation' stamp: 'CyrilFerlicot 11/16/2015 15:47'!
newDataSource: aDataSource
	^ self new
		newDataSource: aDataSource;
		yourself! !

!GLMDataSourceUpdated methodsFor: 'accessing' stamp: 'usmanbhatti 11/16/2015 14:37'!
newDataSource
	^ newDataSource! !

!GLMDataSourceUpdated methodsFor: 'accessing' stamp: 'usmanbhatti 11/16/2015 14:37'!
newDataSource: anObject
	newDataSource := anObject! !

FTFilter subclass: #GLMFilterBlock
	instanceVariableNames: 'filterBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-FastTable-Model'!

!GLMFilterBlock commentStamp: 'JurajKubelka 4/10/2017 11:42' prior: 0!
I implement a filter for fast table. The filter (filterBlock) is a BlockClosure with two arguments. The first argument is a filtered item, the second argument is a string pattern. The block has to return true if the item should be displayed; false otherwise.!

!GLMFilterBlock class methodsFor: 'instance creation' stamp: 'JurajKubelka 4/10/2017 11:24'!
block: aBlockClosure
	^ self new filterBlock: aBlockClosure; yourself! !

!GLMFilterBlock methodsFor: 'accessing' stamp: 'JurajKubelka 4/10/2017 11:24'!
filterBlock
	^ filterBlock! !

!GLMFilterBlock methodsFor: 'accessing' stamp: 'JurajKubelka 4/10/2017 11:44'!
filterBlock: anObject
	"Two argument block: 
		- filtered item
		- string pattern.
	The block should return boolean value."
	filterBlock := anObject! !

!GLMFilterBlock methodsFor: 'testing' stamp: 'JurajKubelka 4/10/2017 11:43'!
matches: anObject
	"Return true if anObject should be displayed; false otherwise."
	self filterBlock ifNil: [ ^ true ].
	^ self filterBlock valueWithEnoughArguments: { anObject. pattern }! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'JurajKubelka 5/11/2017 10:30'!
fastListDoubleClickAction
	<glmBrowser: 'Fast List with double click action' input: 'Object allSubclasses'>
	"self new fastListDoubleClickAction openOn: Object allSubclasses"
	|browser |

	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a |
		a fastList 
			title: 'List' translated;
			onChangeOfPort: #strongSelection 
				act: [ :presentation :entity | 
					self inform: 'STRONG selection (double click) on ', presentation strongSelection asString ] ].

	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'JurajKubelka 1/23/2017 21:04'!
fastListDoubleHeight
	"self new fastListDoubleHeight openOn: (Smalltalk allClassesAndTraits)"

	<glmBrowser: 'Fast List With Double Height' input: 'Smalltalk allClassesAndTraits'>
	| browser |
	browser := GLMTabulator new.
	browser row: #Example.
	browser transmit
		to: #Example;
		andShow: [ :a | a fastList 
			display: Smalltalk allClassesAndTraits;
			rowHeight: [ :presentation | presentation class defaultRowHeight * 2 ] ].
	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'JurajKubelka 1/23/2017 21:15'!
fastListDoubleHeightCustomFormat
	"self new fastListDoubleHeightCustomFormat openOn: (Smalltalk allClassesAndTraits)"

	<glmBrowser: 'Fast List With Double Height And Custom Format' input: 'Smalltalk allClassesAndTraits'>
	| browser |
	browser := GLMTabulator new.
	browser row: #Example.
	browser transmit
		to: #Example;
		andShow: [ :a | a fastList 
			display: Smalltalk allClassesAndTraits;
			rowHeight: [ :presentation | presentation class defaultRowHeight * 2 ];
			format: [ :aClass | 
				(Smalltalk ui theme newColumnIn: World for: { 
					aClass asStringMorph. 
					(' with ', aClass methods size printString, ' methods') asStringMorph })
						cellInset: 0; yourself ] ].
	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'JurajKubelka 1/23/2017 21:21'!
fastListDoubleHeightCustomFormatAndTags
	"self new fastListDoubleHeightCustomFormatAndTags openOn: (Smalltalk allClassesAndTraits)"

	<glmBrowser: 'Fast List With Double Height And Custom Format And Tags' input: 'Smalltalk allClassesAndTraits'>
	| browser |
	browser := GLMTabulator new.
	browser row: #Example.
	browser transmit
		to: #Example;
		andShow: [ :a | a fastList 
			display: Smalltalk allClassesAndTraits;
			rowHeight: [ :presentation | presentation class defaultRowHeight * 2 ];
			format: [ :aClass | 
				(Smalltalk ui theme newColumnIn: World for: { 
					aClass asStringMorph. 
					(' with ', aClass methods size printString, ' methods') asStringMorph })
						cellInset: 0; 
						hResizing: #shrinkWrap;
						vResizing: #shrinkWrap;
						yourself ];
			tags: [ :aClass | aClass methods size asString, ' methods' ] ].
	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'JurajKubelka 1/19/2017 22:46'!
fastListDragAndDrop
	<glmBrowser: 'Fast List drag&drop' input: '(1 to: 5) asOrderedCollection'>
	"self new fastListDragAndDrop openOn: (1 to: 5) asOrderedCollection"
	| browser |
	browser := GLMTabulator new.
	browser column: #source; column: #target.
	browser transmit to: #source; andShow: [:a | 
		a fastList 
			title: 'Source';
			display: (1 to: 10);
			allowItemDrag: [:item :list | true ];
			transformDraggedItem: [:item :list | item + 100 ]
			].
	browser transmit to: #target; andShow: [:a |  
		a fastList
			title: 'Target'; 
			display: [:collection | collection ];
			allowDropOnItem: [:draggedObject :targetItem :list | draggedObject isNumber ];
			dropOnItem: [:draggedObject :targetItem :list | 
				list entity addLast: (targetItem + draggedObject).
				list update.
				true ]
			].
	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'EstebanLorenzano 6/18/2015 16:06'!
fastListDropDown
	"self new fastListDropDown openOn: 5"
	<glmBrowser: 'Fast List Drop-down' input: '5'>

	|browser |

	browser := GLMTabulator new.
	browser row: #one size: 30; row: #two.
	browser transmit to: #one; andShow: [:a |
		a dropDownList
			display: [:x | 1 to: x ];
			format: [:number | Text string: number printString attribute: TextColor red]].
	browser transmit from: #one; to: #two; andShow: [:a |
		a fastList
			display: [:x | 1 to: x * 2]].
	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'CyrilFerlicot 11/16/2015 11:44'!
fastListFunctions
	"self new fastListFunctions openOn: ((Smalltalk allClassesAndTraits sort: [ :a :b | a asString < b asString ]) asArray)"

	"This can be done for a fastlist, a fastlist with separators, a fasttable and even a fastftree."

	<glmBrowser: 'Fast List with function' input: '(Smalltalk allClassesAndTraits sort: [ :a :b | a asString < b asString ]) asArray '>
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit
		to: #one;
		andShow:
				[ :a | 
			a fastList
				title: 'Search';
				display: [ :input | input ];
				enableSearch.
			a fastList
				title: 'Filter';
				display: [ :input | input ];
				enableFilter.
			a fastList
				title: 'Filter and action';
				display: [ :input | input ];
				enableFilterWithAction: [ :dataSource :pattern :selectedRow | selectedRow browse ].
			a fastList
				title: 'Filter and named action ';
				display: [ :input | input ];
				enableFilterWithAction: [ :dataSource :pattern :selectedRow | selectedRow browse ] named: 'Browse' ].
	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'AndreiChis 2/2/2017 19:38'!
fastListMultipleSelection
	"self new fastListMultipleSelection openOn: 10"
	<glmBrowser: 'Fast List Multiple Selection' input: '10'>

	|browser |

	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser transmit to: #one; andShow: [:a |
		a fastList
			beMultiple;
			display: [:x | 1 to: x ]].
	browser transmit from: #one; to: #two; andShow: [:a |
		a fastList ].
	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'usmanbhatti 10/13/2015 11:08'!
fastListOutlineSimple
	"self new fastListOutlineSimple openOn: Object"

	<glmBrowser: 'Fast List Outline Simple' input: 'Object'>
	| browser |
	browser := GLMTabulator new.
	browser row: #Example.
	browser transmit
		to: #Example;
		andShow: [ :a | 
			a fastList
				title: 'Example with an Outline List';
				display: [ :x | x allSubclasses collect: [ :each | each allSubclasses ] ];
				withSeparators ].
	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'CyrilFerlicot 11/9/2015 16:14'!
fastListOutlineWithTag
	"self new fastListOutlineWithTag openOn: Object"

	<glmBrowser: 'Fast List Outline with Tag' input: 'Object'>
	| browser |
	browser := GLMTabulator new.
	browser row: #Example.
	browser transmit
		to: #Example;
		andShow:
				[ :a | 
			a fastList
				title: 'Example with an Outline List';
				display: [ :x | x allSubclasses collect: [ :each | each allSubclasses ] ];
				withSeparators;
				tags: [ :item | item asString first asString ] ].
	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'CyrilFerlicot 10/6/2015 15:37'!
fastListSimple
	"self new fastListSimple openOn: (Smalltalk allClassesAndTraits)"

	<glmBrowser: 'Fast List Simple' input: 'Smalltalk allClassesAndTraits'>
	| browser |
	browser := GLMTabulator new.
	browser row: #Example.
	browser transmit
		to: #Example;
		andShow: [ :a | a fastList display: Smalltalk allClassesAndTraits ].
	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'EstebanLorenzano 6/18/2015 12:04'!
fastTableSimple
	<glmBrowser: 'Fast Table simple' input: '100'>
	"| f | 
	f := self new simpleTable.
	f openOn: 1000.
	(f panes first port: #selection) value: 1"
	| wrapper |	
	wrapper := GLMWrapper new.
	wrapper show: [:a | 
		a fastTable
			display: [ :x | 1 to: x ]; 
			column: [:x | 'Numbers from 1 to ', x asString] evaluated: #asString;
			column: 'Even' evaluated: [ :each | each even asString ];
			column: 'Odd' evaluated: [ :each | each odd asString ] ].
	^ wrapper! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'EstebanLorenzano 6/18/2015 12:04'!
fastTableWithIcons
	<glmBrowser: 'Fast Table with icons' input: '($A to: $z)'>
	"self new tableWithIcons openOn: ($A to: $z)"
	|browser |
	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser transmit to: #one; andShow: [ :a |
		a act: [:presentation | presentation inspect] entitled: 'Inspect'. 
		a fastTable
			title: 'Table with actions';
			act: [:presentation | presentation inspect] entitled: 'Inspect'; 
			column: 'Character' evaluated: [ :each | each asString ];
			column: 'ASCII' evaluated: [ :each | each asInteger printString ];
			selectionAct: [:tree | tree selection inspect ] on: $i entitled: 'Inspect';
			icon: [:each | 
				each asInteger odd 
					ifTrue: [ GLMUIThemeExtraIcons glamorousRedCircle ] 
					ifFalse: [ GLMUIThemeExtraIcons glamorousGreenCircle ] ]].
	
	browser transmit 
		to: #two; 
		from: #one; 
		andShow: [:a | a text ].
	
	browser transmit
		from: #one port: #strongSelection;
		to: #two;
		andShow: [ :a | a text format: [ :item | 'STRONG: ', item asString ] ].
	
	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'CyrilFerlicot 11/4/2015 16:13'!
fastTableWithSearch
	<glmBrowser: 'Fast Table with search' input: '100'>
	"| f | 
	f := self new fastTableWithSearch.
	f openOn: 1000.
	(f panes first port: #selection) value: 1"
	| wrapper |	
	wrapper := GLMWrapper new.
	wrapper show: [:a | 
		a fastTable
			display: [ :x | 1 to: x ]; 
			column: [:x | 'Numbers from 1 to ', x asString] evaluated: #asString;
			column: 'Even' evaluated: [ :each | each even asString ];
			column: 'Odd' evaluated: [ :each | each odd asString ];
			enableSearch;
			allowDeselection ].
	^ wrapper! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'CyrilFerlicot 11/10/2015 14:08'!
fastTreeSimple
	"self new fastTreeSimple openOn: (GLMPresentation allSubclasses sort: [:a :b | a asString < b asString])"

	<glmBrowser: 'Fast Tree Simple' input: '(GLMPresentation allSubclasses sort: [:a :b | a asString < b asString])'>
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit
		to: #one;
		andShow: [ :a | 
			a fastTree
				title: 'Fast Tree';
				children: [ :class | class subclasses sort: [ :b :c | b asString < c asString ] ].
			a fastTree
				title: 'Fast Expanded';
				children: [ :class | class subclasses sort: [ :b :c | b asString < c asString ] ];
				allExpanded.
			a fastTree
				title: 'Fast Tree Root Expanded';
				children: [ :class | class subclasses sort: [ :b :c | b asString < c asString ] ];
				rootsExpanded.
			a fastTree
				title: 'Fast Tree Expanded Until 1';
				children: [ :class | class subclasses sort: [ :b :c | b asString < c asString ] ];
				expandedUntil: 1.
				 ].
	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'CyrilFerlicot 11/10/2015 14:16'!
fastTreeStrategies
	"self new fastTreeStrategies openOn: (GLMPresentation allSubclasses sort: [:a :b | a asString < b asString])"

	<glmBrowser: 'Fast Tree Function Strategies' input: '(GLMPresentation allSubclasses sort: [:a :b | a asString < b asString])'>
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit
		to: #one;
		andShow: [ :a | 
			a fastTree
				title: 'Fast Tree Filter Visibles';
				children: [ :class | class subclasses sort: [ :b :c | b asString < c asString ] ];
				enableFilter; "Could be search also"
				strategy: #default. "Optional in this case."
			a fastTree
				title: 'Fast Tree Filter Roots';
				children: [ :class | class subclasses sort: [ :b :c | b asString < c asString ] ];
				enableFilter;
				strategy: #rootsOnly.
			a fastTree
				title: 'Fast Tree Filter All';
				children: [ :class | class subclasses sort: [ :b :c | b asString < c asString ] ];
				enableFilter;
				strategy: #allItems.
			a fastTree
				title: 'Fast Tree Search All';
				children: [ :class | class subclasses sort: [ :b :c | b asString < c asString ] ];
				enableSearch;
				strategy: #allItems.
				 ].
	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'AndreiChis 2/5/2017 17:24'!
fastTreeWithColumnsAndEditing
	"self new fastTreeWithColumnsAndEditing openOn: ((1 to: 5) collect: [ :index1 |
	((1 to: 10) collect: [ :index | index -> (ValueHolder new contents: 'description') ]) asDictionary ]) "

	<glmBrowser: 'Fast Tree With Editable Columns' input: '((1 to: 5) collect: [ :index1 |
	((1 to: 10) collect: [ :index | index -> (ValueHolder new contents: ''description'') ]) asDictionary ])'>
	| browser |
	browser := GLMTabulator new.
	browser row: #Example.
	browser transmit
		to: #Example;
		andShow: [ :a | a fastTreeTable 
			children: [ :x | x isDictionary ifTrue: [ x associations ] ifFalse: [ #() ] ];
			column: [:x | 'Numbers'] evaluated: [ :value | value isDictionary ifTrue: [ value ] ifFalse: [ value key ] ];
			column: 'Description' 
			   evaluated: [ :value | value isDictionary ifTrue: [ '' ] ifFalse: [ value value contents ] ] 
			   modified: [ :newText :value :presentation | 
					value isDictionary ifFalse: [ value value contents: newText  ]] ].
	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'AndreiChis 2/5/2017 15:38'!
fastTreeWithColumnsSimple
	"self new fastTreeWithColumnsSimple openOn: (1 to: 10)"

	<glmBrowser: 'Fast Tree With Columns' input: '(1 to: 10)'>
	| browser |
	browser := GLMTabulator new.
	browser row: #Example.
	browser transmit
		to: #Example;
		andShow: [ :a | a fastTreeTable 
			children: [ :x | 1 to: x-1 ];
			column: [:x | 'Numbers from 1 to ', x asString] evaluated: #asString;
			column: 'Even' evaluated: [ :each | each even asString ];
			column: 'Odd' evaluated: [ :each | each odd asString ];
			icon: [ :each | 
				each asInteger odd
					ifTrue: [ GLMUIThemeExtraIcons glamorousRedCircle ]
					ifFalse: [ GLMUIThemeExtraIcons glamorousGreenCircle ] ] ].
	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'CyrilFerlicot 11/16/2015 10:04'!
fastTreeWithIcon
	"self new fastTreeWithIcon openOn: (1 to: 10)"

	<glmBrowser: 'Fast Tree With Icon' input: '(1 to: 10)'>
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit
		to: #one;
		andShow:
				[ :a | 
			a fastTree
				title: 'Fast Tree';
				children: [ :x | 1 to: x - 1 ];
				icon: [ :each | 
					each asInteger odd
						ifTrue: [ GLMUIThemeExtraIcons glamorousRedCircle ]
						ifFalse: [ GLMUIThemeExtraIcons glamorousGreenCircle ] ] ].
	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'AndreiChis 2/5/2017 15:41'!
fastTreeWithLazyChildren
	"self new fastTreeWithLazyChildren openOn: (1 to: 10)"

	<glmBrowser: 'Fast Tree Lazy Children' input: '(1 to: 10)'>
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit
		to: #one;
		andShow: [ :a | 
			a fastTree
				title: 'Fast Tree';
				hasChildren: [ :x | x > 2 ];
				children: [ :x | 1 to: x - 1 ] ].
	^ browser! !

!GLMBasicExamples methodsFor: '*Glamour-FastTable' stamp: 'CyrilFerlicot 11/10/2015 13:52'!
tagBlockWith: num
	| tagBlock |
	tagBlock := [ :item | 
	item isNumber
		ifTrue:
			[ {(item even
				ifTrue: [ 'even' ]
				ifFalse: [ 'odd' ]).
			(item < num
				ifTrue: [ '<' , num asString ]
				ifFalse: [ '>=' , num asString ])} ] ].
	^ tagBlock! !
